#define SDL_MAIN_HANDLED

#include <SDL2/SDL.h>
#include <stdlib.h>
#include <stdio.h>

#include <lodepng.h>

enum MainEventSDL {

    EvtRedraw   = 1,
    EvtKbDown   = 2,
    EvtKbUp     = 3,
    EvtMsMotion = 4,
    EvtMsButton = 5,
    EvtOther    = 256
};

class Main {
protected:

    SDL_Surface*        screen_surface  = NULL;
    SDL_Window*         sdl_window      = NULL;
    SDL_Renderer*       sdl_renderer;
    SDL_PixelFormat*    sdl_pixel_format;
    SDL_Texture*        sdl_screen_texture;
    SDL_Event           evt;

    Uint32* screen_buffer;
    Uint32  width, height, _scale, _width, _height;
    Uint32  frame_id;
    Uint32  frame_length;
    Uint32  frame_prev_ticks;

    int     vga_x, vga_y, vga_hs, vga_vs;

public:

    // Открытые поля
    int     kb, mx, my, ms, mb;

    // Конструктор и деструктор
     Main(int w, int h, int scale, int fps);
    ~Main();

    // Главные свойства окна
    int     create(int w, int h, int scale, const char* name, int fps);
    int     event();
    void    update();
    void    destroy();
    void    pset(int x, int y, Uint32 cl);
    void    saveframe(const char* dir, int type);
    void    vga(int R, int G, int B, int HS, int VS, int save);
};
