#include <stdlib.h>

#include "obj_dir/Vga.h"
#include "obj_dir/Vcpu.h"

#include "fonts.h"
#include "sdl2.cc"

// Реальная скорость выше в 8 раз
// Симуляция 3.125 Мгц = 125000
// 1 млн x 25 загрузка 100% хост-процессора
#define CLOCK_FRAME (125000*8)

int main(int argc, char **argv) {

    // Видеопамять
    unsigned char memory[8192];

    // -------------------------------------
    Verilated::commandArgs(argc, argv);
    Main* app = new Main(640, 400, 2, 25);
    Vga*  vga = new Vga;
    Vcpu* cpu = new Vcpu;
    // -------------------------------------

    // Загрузить шрифты и видеообласть
    for (int i = 0; i < 4096; i++) memory[i] = asciicp866[i];
    for (int i = 0; i < 2048; i++) {

        memory[2*i+4096] = i;
        memory[2*i+4097] = 0x17;
    }

    vga->cursor = 1;

    // Обработка возникшего события
    while (int event = app->event()) {

        // 1 кадр = 1 млн тактов
        if (event == EvtRedraw) {

            for (int i = 0; i < CLOCK_FRAME; i++) {

                // Один такт для VGA | CPU
                vga->clock = 0; vga->eval();
                cpu->clock = 0; cpu->eval();
                vga->clock = 1; vga->eval();
                cpu->clock = 1; cpu->eval();

                // Обнаружен сигнал записи в память
                if (cpu->we) memory[ cpu->address ] = cpu->data;

                // Чтение из памяти для VGA
                vga->data = memory[ vga->address ];

                // Симуляция монитора
                app->vga(vga->R<<4, vga->G<<4, vga->B<<4, vga->HS, vga->VS, 1);
            }

            if (Verilated::gotFinish()) break;
        }
    }

    delete app;
    delete vga;

    exit(EXIT_SUCCESS);
}
